# $Id: conserver.spec 5231 2007-03-18 20:46:57Z dag $
# Authority: dag
# Upstream: <users$conserver,com>
# Upstream: Bryan Stansell <bryan$conserver,com>
# CERN: <Andras.Horvath@cern.ch>

### FIXME: Add sysv script using sysconfig file.

Summary: Serial console server daemon/client
Name: conserver
Version: 8.1.16
Release: gssapi_cern.27
License: BSD style
Group: System Environment/Daemons
URL: http://www.conserver.com/

Packager: Andras.Horvath@cern.ch
Vendor: Dag Apt Repository, http://dag.wieers.com/apt/

Source: http://www.conserver.com/conserver-%{version}.tar.gz
Patch0: conserver-cern.patch
Patch1: conserver-8.1.16-gssglue.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
# just in case.
BuildRequires: pam-devel openssl-devel krb5-devel libgssapi-devel

%description
Conserver is an application that allows multiple users to watch a
serial console at the same time.  It can log the data, allows users to
take write-access of a console (one at a time), and has a variety of
bells and whistles to accentuate that basic functionality.

This package differs from the DAG version in that it runs as a non-privileged
user and contains an extra script for IPMI integration, and sane config file
defaults.

%package server
Summary: Serial console server daemon
Group: System Environment/Daemons
%description server
Conserver is an application that allows multiple users to watch a
serial console at the same time.  It can log the data, allows users to
take write-access of a console (one at a time), and has a variety of
bells and whistles to accentuate that basic functionality.

This package differs from the DAG version in that it runs as a non-privileged
user and contains an extra script for IPMI integration, and sane config file
defaults.

This is the server part that runs on the headnodes.

%package client
Summary: Serial console client for conserver-server
Group: System Environment/Daemons
%description client
Conserver is an application that allows multiple users to watch a
serial console at the same time.  It can log the data, allows users to
take write-access of a console (one at a time), and has a variety of
bells and whistles to accentuate that basic functionality.

This package differs from the DAG version in that it runs as a non-privileged
user and contains an extra script for IPMI integration, and sane config file
defaults.

This is the client that accesses the server.

%prep
%setup
%patch0 -p1
%patch1 -p1

### FIXME: We don't want to install the solaris conserver.rc file.
%{__perl} -pi.orig -e 's|^.*conserver\.rc.*$||' conserver/Makefile.in

%build
%configure \
    --with-pam \
    --with-openssl \
    --with-gssapi \
    --with-logfile=/var/log/console/__server.log
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%makeinstall
%{__install} -Dp -m0644 conserver.cf/conserver.cf %{buildroot}%{_sysconfdir}/conserver.cf
#%{__install} -Dp -m0600 conserver.cf/conserver.passwd %{buildroot}%{_sysconfdir}/conserver.passwd
%{__install} -Dp -m0755 contrib/redhat-rpm/conserver.init %{buildroot}%{_initrddir}/conserver
# add-ons
%{__install} -Dp -m0644 console.cf %{buildroot}%{_sysconfdir}/console.cf
%{__install} -Dp -m0640 contrib/exec/conserver-exec.cf %{buildroot}%{_sysconfdir}/conserver-exec.cf
%{__install} -Dp -m0755 contrib/exec/conserver-exec %{buildroot}%{_sbindir}/conserver-exec
%{__install} -Dp -m0644 contrib/exec/conserver-exec.cron %{buildroot}%{_sysconfdir}/cron.d/conserver-exec.cron
# no logrotate -- let the daemon handle this
# logrotate is too stupid for multilevel directories
#%{__install} -Dp -m0644 contrib/logrotate/conserver.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/conserver
%{__install} -Dp -m0644 contrib/pam/conserver %{buildroot}%{_sysconfdir}/pam.d/conserver
%{__install} -Dp -m0644 contrib/passwd/conserver.passwd %{buildroot}%{_sysconfdir}/conserver.passwd

%post server
/sbin/chkconfig --add conserver
if ! egrep -q '\<conserver\>' /etc/services; then
    echo "console       7782/tcp     conserver" >> /etc/services
fi
if ! egrep -q '\<conserver child\>' /etc/services; then
    echo "console-child       7783/tcp     conserver child processes" >> /etc/services
fi
mkdir -p /var/log/console/oldlogs
chown -R root:uucp /var/log/console
chmod 2775 /var/log/console/oldlogs
chmod 2775 /var/log/console/
find /var/log/console -type f -print0  | xargs -0 -r chmod 664

%preun server
if [ $1 -eq 0 ]; then
    /sbin/service conserver stop &>/dev/null || :
    /sbin/chkconfig --del conserver
fi

#%postun
#/sbin/service conserver condrestart &>/dev/null || :

%clean
%{__rm} -rf %{buildroot}

%files client
%defattr(-, root, root, 0755)
%attr(0644, root, uucp) %config(noreplace) %{_sysconfdir}/console.cf
%doc %{_mandir}/man?/console*
%{_bindir}/console

%files server
%defattr(-, root, root, 0755)
%doc CHANGES FAQ INSTALL README conserver.cf/
%doc %{_mandir}/man?/conserver*
%attr(0644, root, uucp) %config(noreplace) %{_sysconfdir}/conserver.cf
%attr(0640, root, uucp) %config(noreplace) %{_sysconfdir}/conserver-exec.cf
%attr(0644, root, uucp) %config(noreplace) %{_sysconfdir}/conserver.passwd
%attr(0644, root, uucp) %config(noreplace) %{_sysconfdir}/pam.d/conserver
# no more logrotate,  see above
#%attr(0644, root, uucp) %config(noreplace) %{_sysconfdir}/logrotate.d/conserver
%attr(0644, root, uucp) %config(noreplace) %{_sysconfdir}/cron.d/conserver-exec.cron
%config %{_initrddir}/conserver
%{_sbindir}/conserver-exec
%{_sbindir}/conserver
%{_libdir}/conserver/
%exclude %{_datadir}/examples/

%changelog
* Fri Sep 18 2009  Andras HORVATH <andras.horvath@cern.ch> 8.1.16-gssapi_cern.27
- patch: retry logging in with 'user' if 'user@REALM' fails

* Wed Sep 16 2009  Andras HORVATH <andras.horvath@cern.ch> 8.1.16-cern.21
- separate client and server RPMs

* Wed Sep 16 2009  Andras HORVATH <andras.horvath@cern.ch> 8.1.16-cern.20
- removed logrotate

* Fri Sep  4 2009  Andras HORVATH <andras.horvath@cern.ch> 8.1.16-cern.19
- add '-m 500' to prevent opening of too many ports (more iptables-able)

* Wed Dec 17 2008 Andras Horvath <Andras.Horvath@cern.ch> 8.1.16-cern.18
- conserver-exec: better error handling, no 'deactivate', ping first
- !autoreinit, plus cron job to restart 'down' consoles (this makes for a
  closer connection between status and actuality for IPMI consoles)

* Mon Dec 15 2008 Andras Horvath <Andras.Horvath@cern.ch> 8.1.16-cern.15
- ship generic, PAM-aware conserver.passwd
- ship /etc/pam.d/conserver (KRB5, cern-specific)

* Thu Nov 13 2008 Andras Horvath <Andras.Horvath@cern.ch> 8.1.16-cern.1
- First modified release with CERN patch:
- runs as uucp (modified startup script)
- provides console.cf, sanitizes conserver.cf, removes conserver.passwd
- adds 'conserver-exec' script with config file
- modified init script 'restart' target

* Thu Sep 25 2008 Dag Wieers <dag@wieers.com> - 8.1.16-1 - 5231+/dag
- Updated to release 8.1.16.

* Sun Mar 18 2007 Dag Wieers <dag@wieers.com> - 8.1.15-1
- Updated to release 8.1.15.

* Tue Apr 11 2006 Dag Wieers <dag@wieers.com> - 8.1.14-1
- Updated to release 8.1.14.

* Mon Jan 16 2006 Dag Wieers <dag@wieers.com> - 8.1.13-1
- Updated to release 8.1.13.

* Tue Jan 03 2006 Dag Wieers <dag@wieers.com> - 8.1.12-1
- Updated to release 8.1.12.

* Sat May 29 2004 Dag Wieers <dag@wieers.com> - 8.1.7-1
- Updated to release 8.1.7.

* Thu May 27 2004 Dag Wieers <dag@wieers.com> - 8.1.6-1
- Updated to release 8.1.6.

* Tue May 11 2004 Dag Wieers <dag@wieers.com> - 8.1.5-1
- Updated to release 8.1.5.

* Thu Apr 15 2004 Dag Wieers <dag@wieers.com> - 8.1.4-1
- Updated to release 8.1.4.

* Fri Mar 26 2004 Dag Wieers <dag@wieers.com> - 8.1.3-1
- Updated to release 8.1.3.

* Sat Mar 13 2004 Dag Wieers <dag@wieers.com> - 8.1.2-0
- Updated to release 8.1.2.

* Fri Dec 12 2003 Dag Wieers <dag@wieers.com> - 8.0.9-0
- Updated to release 8.0.9.

* Sun Nov 23 2003 Dag Wieers <dag@wieers.com> - 8.0.7-0
- Updated to release 8.0.7.

* Mon Oct 13 2003 Dag Wieers <dag@wieers.com> - 8.0.1-1
- Fixed a %%post problem.

* Wed Oct 01 2003 Dag Wieers <dag@wieers.com> - 8.0.1-0
- Updated to release 8.0.1.

* Mon Sep 15 2003 Dag Wieers <dag@wieers.com> - 7.2.7-0
- Initial package. (using DAR)
